import { P as D, W as q, c as X, A as j, F as $, w as ee, s as te, o as le, _ as re, a6 as ie, x as ae, C as se, y as ne, a4 as ce, e as oe, r as he, f as U, a7 as ue, R as de, S as ge, q as fe, b as Ie, z as me, d as Ne, a8 as be, v as xe, a9 as Fe, a2 as _e, aa as Ae, i as ye, G as Le, L as Ce, u as Se, p as ke, B as we, a as Oe, t as Ge } from "./index-DaOY9hvr.js";
import { D as ve } from "./DataTable-BF8jSYP_.js";
import { _ as pe } from "./Title-DA-ToubT.js";
import { u as ze, _ as Me } from "./Tooltip-DbjT4bdy.js";
import { U as Te } from "./usePrinter-DqRlipuX.js";
import { _ as Pe } from "./Shape-hvBooorF.js";
import Ve from "./BaseIcon-BjAKZREF.js";
import Re from "./vue-ui-table-sparkline-UyU28o32.js";
import De from "./vue-ui-skeleton-D0_Nq8rw.js";
import { S as He } from "./Slicer-DnFM9Cfy.js";
import We from "./vue-ui-accordion-B7y_o2CM.js";
import { u as Z } from "./useNestedProp-Da76X-ip.js";
import { _ as Be } from "./PackageVersion-BiK7Dx4X.js";
import { P as Ee } from "./PenAndPaper-BzFJd7bn.js";
import { resolveComponent as R, createElementBlock as s, openBlock as i, normalizeStyle as F, normalizeClass as W, createBlock as H, createCommentVNode as h, createVNode as Y, createSlots as Ye, withCtx as P, renderSlot as S, normalizeProps as B, guardReactiveProps as E, createElementVNode as d, createTextVNode as J, Fragment as g, renderList as m, toDisplayString as w, mergeProps as K, withDirectives as qe, vModelCheckbox as Xe } from "vue";
import { _ as Ue } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ze = X(), Je = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: ve,
    Shape: Pe,
    Title: pe,
    Tooltip: Me,
    UserOptions: Te,
    BaseIcon: Ve,
    TableSparkline: Re,
    Skeleton: De,
    Slicer: He,
    Accordion: We,
    PackageVersion: Be,
    PenAndPaper: Ee
  },
  data() {
    this.dataset.forEach((u, l) => {
      [null, void 0].includes(u.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: l
      });
    });
    const t = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, a = Math.max(...this.dataset.map((u) => this.largestTriangleThreeBucketsArray({ data: u.series, threshold: t }).length)), o = {
      start: 0,
      end: a
    };
    return {
      themePalettes: Ge,
      themes: Oe,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: we,
      useSafeValues: !0,
      palette: ke,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: X(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: o,
      __to__: null,
      maxX: a,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Ze,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null,
      showUserOptionsOnChartHover: !1,
      keepUserOptionState: !0,
      userOptionsVisible: !0,
      svgRef: null
    };
  },
  watch: {
    dataset: {
      handler(t, a) {
        this.maxX = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({
          data: o.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(t, a) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1, this.mutableConfig = {
          dataLabels: {
            show: !0
          },
          showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
          showTable: this.FINAL_CONFIG.showTable === !0,
          isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
          useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
        };
      },
      deep: !0
    }
  },
  computed: {
    chartAriaLabel() {
      const t = this.FINAL_CONFIG.chart.title.text || "Chart visualization", a = this.FINAL_CONFIG.chart.title.subtitle.text || "";
      return `${t}. ${a}`;
    },
    optimize() {
      return {
        linePlot: this.maxSeries > this.FINAL_CONFIG.line.dot.hideAboveMaxSerieLength
      };
    },
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const t = this.datasetWithIds.filter((l) => !this.segregatedSeries.includes(l.id)), a = Math.max(...t.map((l) => l.series.length)), o = [];
      for (let l = 0; l < a; l += 1)
        o.push(t.map((e) => e.series[l] || 0).reduce((e, A) => (e || 0) + (A || 0), 0));
      const u = Math.min(...o);
      return o.map((l) => l + (u < 0 ? Math.abs(u) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const t = this.lineSet.map((e) => ({
        name: e.name,
        color: e.color,
        scale: e.individualScale,
        scaleYLabels: e.scaleYLabels,
        zero: e.zeroPosition,
        max: e.individualMax,
        scaleLabel: e.scaleLabel || "",
        id: e.id,
        yOffset: e.yOffset || 0,
        individualHeight: e.individualHeight || this.drawingArea.height,
        autoScaleYLabels: e.autoScaleYLabels
      })), a = this.barSet.map((e) => ({
        name: e.name,
        color: e.color,
        scale: e.individualScale,
        scaleYLabels: e.scaleYLabels,
        zero: e.zeroPosition,
        max: e.individualMax,
        scaleLabel: e.scaleLabel || "",
        id: e.id,
        yOffset: e.yOffset || 0,
        individualHeight: e.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((e) => ({
        name: e.name,
        color: e.color,
        scale: e.individualScale,
        scaleYLabels: e.scaleYLabels,
        // FIX
        zero: e.zeroPosition,
        max: e.individualMax,
        scaleLabel: e.scaleLabel || "",
        id: e.id,
        yOffset: e.yOffset || 0,
        individualHeight: e.individualHeight || this.drawingArea.height
      })), u = this.mutableConfig.useIndividualScale && !this.mutableConfig.isStacked ? Object.values(this.scaleGroups) : [...t, ...a, ...o];
      console.log(u);
      const l = u.flatMap((e) => e).length;
      return u.flatMap((e, A) => ({
        unique: e.unique,
        id: e.id,
        groupId: e.groupId,
        scaleLabel: e.scaleLabel,
        name: e.unique ? e.name : e.groupName,
        color: e.unique ? e.color : e.groupColor,
        scale: e.scale,
        yOffset: e.yOffset,
        individualHeight: e.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / l * (A + 1),
        yLabels: e.scaleYLabels || e.scale.ticks.map((N) => ({
          y: N >= 0 ? e.zero - e.individualHeight * (N / e.max) : e.zero + e.individualHeight * Math.abs(N) / e.max,
          value: N
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const t = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(t, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(t) {
        return t;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((t) => t.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((a) => ({
          ...a,
          span: a.from === a.to ? 1 : a.to < a.from ? 0 : a.to - a.from + 1
        }));
      const t = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...t, span: t.from === t.to ? 1 : t.to < t.from ? 0 : t.to - t.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return [null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) ? this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min) : -this.niceScale.min;
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((t, a) => ({
        ...t,
        series: this.largestTriangleThreeBucketsArray({
          data: t.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${a}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((t, a) => {
        const o = this.largestTriangleThreeBucketsArray({
          data: t.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }), u = `uniqueId_${a}`;
        return {
          ...t,
          slotAbsoluteIndex: a,
          series: o.map((l) => this.isSafeValue(l) ? l : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(t.color ? t.color : this.customPalette[a] ? this.customPalette[a] : this.palette[a]),
          id: u,
          scaleLabel: t.scaleLabel || u
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((t, a) => ({
        ...t,
        series: t.series.map((o) => o + this.relativeZero),
        absoluteValues: t.series
      })).filter((t) => !this.segregatedSeries.includes(t.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((t) => {
        const a = t.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: t.id,
          name: t.name,
          color: t.color,
          values: this.fillArray(this.maxSeries, a)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((t, a) => ({
        absoluteIndex: a,
        ...t,
        series: t.series.map((o) => o + this.relativeZero),
        absoluteValues: t.series,
        segregate: () => this.segregate(t),
        isSegregated: this.segregatedSeries.includes(t.id)
      }));
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((t) => !this.segregatedSeries.includes(t.id)));
    },
    scaleGroups() {
      const t = Object.groupBy(this.activeSeriesWithStackRatios, (o) => o.scaleLabel), a = {};
      for (const [o, u] of Object.entries(t)) {
        const l = u.flatMap((e) => e.absoluteValues);
        a[o] = {
          min: Math.min(...l) || 0,
          max: Math.max(...l) || 1,
          groupId: `scale_group_${this.createUid()}`
        };
      }
      return a;
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "bar").map((t, a) => {
        this.checkAutoScaleError(t);
        const o = this.scaleGroups[t.scaleLabel].min, u = this.scaleGroups[t.scaleLabel].max;
        t.absoluteValues.filter((x) => ![null, void 0].includes(x)).map((x) => (x - o) / (u - o));
        const l = {
          valueMin: o,
          valueMax: u < 0 ? 0 : u
        }, e = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || Math.min(...t.absoluteValues.filter((x) => ![void 0, null].includes(x))) > 0 ? 0 : Math.min(...t.absoluteValues.filter((x) => ![null, void 0].includes(x)))
        }, A = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, N = 1.0000001, I = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * N : e.max, A), y = this.calculateNiceScaleWithExactExtremes(l.valueMin, l.valueMax === l.valueMin ? l.valueMax * N : l.valueMax, A), v = I.min >= 0 ? 0 : Math.abs(I.min), O = 0, p = I.max + v, G = y.max + Math.abs(O), b = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, L = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, z = this.drawingArea.bottom - b - L * v / p, V = this.drawingArea.bottom - b - L * O / G, r = this.absoluteDataset.filter((x) => x.type === "bar").filter((x) => !this.segregatedSeries.includes(x.id)).length, c = t.series.map((x, T) => {
          const _ = this.mutableConfig.useIndividualScale ? (t.absoluteValues[T] + v) / p : this.ratioToMax(x), k = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * T : this.drawingArea.left + this.slot.bar * a + this.slot.bar * T * r - this.barSlot / 2 - a * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(b),
            individualHeight: this.checkNaN(L),
            x: this.checkNaN(k),
            y: this.drawingArea.bottom - b - L * _,
            value: t.absoluteValues[T],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(p),
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[T] || ""
          };
        }), n = t.absoluteValues.map((x) => y.min >= 0 ? (x - Math.abs(y.min)) / (y.max - Math.abs(y.min)) : (x + Math.abs(y.min)) / (y.max + Math.abs(y.min))), f = t.series.map((x, T) => {
          const _ = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * T : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * a + this.slot.bar * T * this.absoluteDataset.filter((k) => k.type === "bar").filter((k) => !this.segregatedSeries.includes(k.id)).length;
          return {
            yOffset: this.checkNaN(b),
            individualHeight: this.checkNaN(L),
            x: this.checkNaN(_),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(b) - (this.checkNaN(L) * n[T] || 0)),
            value: t.absoluteValues[T],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(p),
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[T] || ""
          };
        }), C = I.ticks.map((x) => ({
          y: x >= 0 ? z - L * (x / p) : z + L * Math.abs(x) / p,
          value: x,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), M = y.ticks.map((x) => {
          const T = (x - y.min) / (y.max - y.min);
          return {
            y: x >= 0 ? V - L * T : V + L * T,
            value: x,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return this.scaleGroups[t.scaleLabel].name = t.name, this.scaleGroups[t.scaleLabel].groupName = t.scaleLabel, this.scaleGroups[t.scaleLabel].groupColor = this.FINAL_CONFIG.chart.grid.labels.yAxis.groupColor || t.color, this.scaleGroups[t.scaleLabel].color = t.color, this.scaleGroups[t.scaleLabel].scaleYLabels = t.autoScaling ? M : C, this.scaleGroups[t.scaleLabel].zeroPosition = t.autoScaling ? V : z, this.scaleGroups[t.scaleLabel].individualMax = t.autoScaling ? G : p, this.scaleGroups[t.scaleLabel].scaleLabel = t.scaleLabel, this.scaleGroups[t.scaleLabel].id = t.id, this.scaleGroups[t.scaleLabel].yOffset = b, this.scaleGroups[t.scaleLabel].individualHeight = L, this.scaleGroups[t.scaleLabel].autoScaleYLabels = M, this.scaleGroups[t.scaleLabel].unique = this.activeSeriesWithStackRatios.filter((x) => x.scaleLabel === t.scaleLabel).length === 1, {
          ...t,
          yOffset: b,
          autoScaleYLabels: M,
          individualHeight: L,
          scaleYLabels: t.autoScaling ? M : C,
          individualScale: t.autoScaling ? y : I,
          individualMax: t.autoScaling ? G : p,
          zeroPosition: t.autoScaling ? V : z,
          plots: t.autoScaling ? f : c,
          groupId: this.scaleGroups[t.scaleLabel].groupId
        };
      });
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "line").map((t) => {
        this.checkAutoScaleError(t);
        const a = this.scaleGroups[t.scaleLabel].min, o = this.scaleGroups[t.scaleLabel].max;
        t.absoluteValues.filter((_) => ![null, void 0].includes(_)).map((_) => (_ - a) / (o - a));
        const u = {
          valueMin: a,
          valueMax: o
        }, l = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || (Math.min(...t.absoluteValues) > 0 ? 0 : Math.min(...t.absoluteValues))
        }, e = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, N = this.calculateNiceScaleWithExactExtremes(l.min, l.max === l.min ? l.max * A : l.max, e), I = this.calculateNiceScaleWithExactExtremes(u.valueMin, u.valueMax === u.valueMin ? u.valueMax * A : u.valueMax, e), y = N.min >= 0 ? 0 : Math.abs(N.min), v = 0, O = N.max + Math.abs(y), p = I.max + Math.abs(v), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, b = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, L = this.drawingArea.bottom - G - b * y / O, z = this.drawingArea.bottom - G - b * v / p, V = t.series.map((_, k) => {
          const Q = this.mutableConfig.useIndividualScale ? (t.absoluteValues[k] + Math.abs(y)) / O : this.ratioToMax(_);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * k),
            y: this.checkNaN(this.drawingArea.bottom - G - b * Q),
            value: t.absoluteValues[k],
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[k] || ""
          };
        }), r = t.absoluteValues.map((_) => I.min >= 0 ? (_ - Math.abs(I.min)) / (I.max - Math.abs(I.min)) : (_ + Math.abs(I.min)) / (I.max + Math.abs(I.min))), c = t.series.map((_, k) => [void 0, null].includes(t.absoluteValues[k]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * k),
          y: L,
          value: t.absoluteValues[k],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[k] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * k),
          y: this.checkNaN(this.drawingArea.bottom - G - (b * r[k] || 0)),
          value: t.absoluteValues[k],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[k] || ""
        }), n = this.createSmoothPath(V.filter((_) => _.value !== null)), f = this.createSmoothPath(c.filter((_) => _.value !== null)), C = this.createStraightPath(V.filter((_) => _.value !== null)), M = this.createStraightPath(c.filter((_) => _.value !== null)), x = N.ticks.map((_) => ({
          y: _ >= 0 ? L - b * (_ / O) : L + b * Math.abs(_) / O,
          value: _,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), T = I.ticks.map((_) => {
          const k = (_ - I.min) / (I.max - I.min);
          return {
            y: _ >= 0 ? z - b * k : z + b * k,
            value: _,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return this.scaleGroups[t.scaleLabel].name = t.name, this.scaleGroups[t.scaleLabel].groupName = t.scaleLabel, this.scaleGroups[t.scaleLabel].groupColor = this.FINAL_CONFIG.chart.grid.labels.yAxis.groupColor || t.color, this.scaleGroups[t.scaleLabel].color = t.color, this.scaleGroups[t.scaleLabel].scaleYLabels = t.autoScaling ? T : x, this.scaleGroups[t.scaleLabel].zeroPosition = t.autoScaling ? z : L, this.scaleGroups[t.scaleLabel].individualMax = t.autoScaling ? p : O, this.scaleGroups[t.scaleLabel].scaleLabel = t.scaleLabel, this.scaleGroups[t.scaleLabel].id = t.id, this.scaleGroups[t.scaleLabel].yOffset = G, this.scaleGroups[t.scaleLabel].individualHeight = b, this.scaleGroups[t.scaleLabel].autoScaleYLabels = T, this.scaleGroups[t.scaleLabel].unique = this.activeSeriesWithStackRatios.filter((_) => _.scaleLabel === t.scaleLabel).length === 1, {
          ...t,
          yOffset: G,
          autoScaleYLabels: T,
          individualHeight: b,
          scaleYLabels: t.autoScaling ? T : x,
          individualScale: t.autoScaling ? I : N,
          individualMax: t.autoScaling ? p : O,
          zeroPosition: t.autoScaling ? z : L,
          curve: t.autoScaling ? f : n,
          plots: t.autoScaling ? c : V,
          area: t.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(t.autoScaling ? c : V, t.autoScaling ? z : L) : this.createArea(V) : "",
          straight: t.autoScaling ? M : C,
          groupId: this.scaleGroups[t.scaleLabel].groupId
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "plot").map((t) => {
        this.checkAutoScaleError(t);
        const a = this.scaleGroups[t.scaleLabel].min, o = this.scaleGroups[t.scaleLabel].max;
        t.absoluteValues.filter((C) => ![null, void 0].includes(C)).map((C) => (C - a) / (o - a));
        const u = {
          valueMin: a,
          valueMax: o
        }, l = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || Math.min(...t.absoluteValues) > 0 ? 0 : Math.min(...t.absoluteValues)
        }, e = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, N = this.calculateNiceScaleWithExactExtremes(l.min, l.max === l.min ? l.max * A : l.max, e), I = this.calculateNiceScaleWithExactExtremes(u.valueMin, u.valueMax === u.valueMin ? u.valueMax * A : u.valueMax, e), y = N.min >= 0 ? 0 : Math.abs(N.min), v = 0, O = N.max + y, p = I.max + Math.abs(v), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, b = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, L = this.drawingArea.bottom - G - b * y / O, z = this.drawingArea.bottom - G - b * v / p, V = t.series.map((C, M) => {
          const x = this.mutableConfig.useIndividualScale ? (t.absoluteValues[M] + Math.abs(y)) / O : this.ratioToMax(C);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * M),
            y: this.checkNaN(this.drawingArea.bottom - G - b * x),
            value: t.absoluteValues[M],
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[M] || ""
          };
        }), r = t.absoluteValues.map((C) => I.min >= 0 ? (C - Math.abs(I.min)) / (I.max - Math.abs(I.min)) : (C + Math.abs(I.min)) / (I.max + Math.abs(I.min))), c = t.series.map((C, M) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * M),
          y: this.checkNaN(this.drawingArea.bottom - G - (b * r[M] || 0)),
          value: t.absoluteValues[M],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[M] || ""
        })), n = N.ticks.map((C) => ({
          y: C >= 0 ? L - b * (C / O) : L + b * Math.abs(C) / O,
          value: C,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), f = I.ticks.map((C) => {
          const M = (C - I.min) / (I.max - I.min);
          return {
            y: C >= 0 ? z - b * M : z + b * M,
            value: C,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return this.scaleGroups[t.scaleLabel].name = t.name, this.scaleGroups[t.scaleLabel].groupName = t.scaleLabel, this.scaleGroups[t.scaleLabel].groupColor = this.FINAL_CONFIG.chart.grid.labels.yAxis.groupColor || t.color, this.scaleGroups[t.scaleLabel].color = t.color, this.scaleGroups[t.scaleLabel].scaleYLabels = t.autoScaling ? f : n, this.scaleGroups[t.scaleLabel].zeroPosition = t.autoScaling ? z : L, this.scaleGroups[t.scaleLabel].individualMax = t.autoScaling ? p : O, this.scaleGroups[t.scaleLabel].scaleLabel = t.scaleLabel, this.scaleGroups[t.scaleLabel].id = t.id, this.scaleGroups[t.scaleLabel].yOffset = G, this.scaleGroups[t.scaleLabel].individualHeight = b, this.scaleGroups[t.scaleLabel].autoScaleYLabels = f, this.scaleGroups[t.scaleLabel].unique = this.activeSeriesWithStackRatios.filter((C) => C.scaleLabel === t.scaleLabel).length === 1, {
          ...t,
          yOffset: G,
          autoScaleYLabels: f,
          individualHeight: b,
          scaleYLabels: t.autoScaling ? f : n,
          individualScale: t.autoScaling ? I : N,
          individualMax: t.autoScaling ? p : O,
          zeroPosition: t.autoScaling ? z : L,
          plots: t.autoScaling ? c : V,
          groupId: this.scaleGroups[t.scaleLabel].groupId
        };
      });
    },
    drawingArea() {
      const t = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((a) => !this.segregatedSeries.includes(a.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + t,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + t)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((t) => !this.segregatedSeries.includes(t.id)).map((t) => Math.max(...t.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const t = Math.min(...this.safeDataset.filter((a) => !this.segregatedSeries.includes(a.id)).map((a) => Math.min(...a.series)));
      return t > 0 ? 0 : t;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      const t = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length)), a = [];
      for (let o = 0; o < t; o += 1)
        a.push({
          text: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[o] || String(o),
          absoluteIndex: o
        });
      return a.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((t) => t.type === "bar").filter((t) => !this.segregatedSeries.includes(t.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const t = this.safeDataset.filter((a) => a.type === "bar").filter((a) => !this.segregatedSeries.includes(a.id)).length;
      return this.drawingArea.width / this.maxSeries / t - this.barPeriodGap * t;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((t) => t !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const t = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), a = [];
      return this.timeLabels.forEach((o, u) => {
        const l = [o.text];
        this.relativeDataset.forEach((e) => {
          l.push(this.canShowValue(e.absoluteValues[u]) ? Number(e.absoluteValues[u].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), a.push(l);
      }), { head: t, body: a };
    },
    dataTable() {
      const t = this.FINAL_CONFIG.table.showSum;
      let a = [""].concat(this.relativeDataset.map((e) => e.name));
      t && (a = a.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const A = this.relativeDataset.map((N) => N.absoluteValues[e] ?? 0).reduce((N, I) => N + I, 0);
        o.push(
          [
            this.timeLabels[e].text ?? "-"
          ].concat(this.relativeDataset.map(
            (N) => this.applyDataLabel(
              N.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : N.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              N.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: N.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: N.absoluteValues[e] ?? 0,
                s: N.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(t ? (A ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const u = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, l = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: a, body: o, config: u, colNames: l };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((t) => ({
        slotAbsoluteIndex: t.slotAbsoluteIndex,
        shape: t.shape || null,
        name: t.name,
        color: t.color,
        type: t.type,
        value: t.absoluteValues.find((a, o) => o === this.selectedSerieIndex),
        comments: t.comments || [],
        prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let t = "", a = this.selectedSeries.map((l) => l.value).filter((l) => this.isSafeValue(l) && l !== null).reduce((l, e) => Math.abs(l) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], u = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(u) && this.functionReturnsString(() => u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && o.text && this.FINAL_CONFIG.chart.tooltip.showTimeLabel && (t += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o.text}</div>`), this.selectedSeries.forEach((l) => {
        if (this.isSafeValue(l.value)) {
          let e = "", A = "";
          switch (this.icons[l.type]) {
            case "bar":
              e = `<svg viewBox="0 0 40 40" height="14" width="14">${this.$slots.pattern ? `<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${l.color}" />` : ""}<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${this.$slots.pattern ? `url(#pattern_${this.uniqueId}_${l.slotAbsoluteIndex}` : l.color}" /></svg>`;
              break;
            case "line":
              !l.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(l.shape) ? A = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${l.color}" />` : l.shape === "triangle" ? A = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : l.shape === "square" ? A = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : l.shape === "diamond" ? A = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : l.shape === "pentagon" ? A = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : l.shape === "hexagon" ? A = `<path d="${D({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : l.shape === "star" && (A = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${l.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="1.5" x="0" y="6.5" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" height="3" width="20" fill="${l.color}" />${A}</svg>`;
              break;
            case "plot":
              if (!l.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(l.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${l.color}" /></svg>`;
                break;
              }
              if (l.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${l.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (l.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (l.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (l.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (l.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (l.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${D({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${l.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          t += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${l.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            l.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : l.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            l.value,
            this.dataLabel({
              p: l.prefix,
              v: l.value,
              s: l.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: l }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(l.value) / a * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && l.comments.length && l.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (t += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${l.color}">${l.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${t}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((t) => ({
        y: t >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(t) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(t)),
        value: t,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.svgRef = this.$refs.svgRef, this.prepareChart(), this.setupSlicer(), document.addEventListener("mousemove", (t) => {
      this.clientPosition = {
        x: t.clientX,
        y: t.clientY
      };
    });
  },
  methods: {
    abbreviate: Ce,
    adaptColorToBackground: Le,
    applyDataLabel: ye,
    assignStackRatios: Ae,
    calcLinearProgression: _e,
    calculateNiceScaleWithExactExtremes: Fe,
    checkNaN: xe,
    closestDecimal: be,
    convertColorToHex: Ne,
    convertConfigColors: me,
    convertCustomPalette: Ie,
    createCsvContent: fe,
    createSmoothPath: ge,
    createStraightPath: de,
    createTSpans: ue,
    dataLabel: U,
    downloadCsv: he,
    error: oe,
    forceValidValue: ce,
    functionReturnsString: ne,
    hasDeepProperty: se,
    isFunction: ae,
    isSafeValue: ie,
    largestTriangleThreeBucketsArray: re,
    objectIsEmpty: le,
    setOpacity: te,
    shiftHue: ee,
    translateSize: $,
    treeShake: j,
    useMouse: ze,
    useNestedProp: Z,
    createUid: X,
    setUserOptionsVisibility(t = !1) {
      this.showUserOptionsOnChartHover && (this.userOptionsVisible = t);
    },
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    selectTimeLabel(t, a) {
      const o = this.relativeDataset.map((u) => ({
        shape: u.shape || null,
        name: u.name,
        color: u.color,
        type: u.type,
        value: u.absoluteValues.find((l, e) => e === a),
        comments: u.comments || [],
        prefix: u.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: u.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
      this.$emit("selectTimeLabel", {
        datapoint: o,
        absoluteIndex: t.absoluteIndex,
        label: t.text
      });
    },
    getHighlightAreaPosition(t) {
      const a = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (t.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * t.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * t.span;
      return {
        x: a < this.drawingArea.left ? this.drawingArea.left : a,
        width: o
      };
    },
    prepareConfig() {
      const t = Se().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return t;
      const a = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: t
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? a.chart.highlightArea = this.config.chart.highlightArea : a.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? a.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : a.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? a.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : a.chart.grid.labels.yAxis.scaleMax = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.startIndex") ? a.chart.zoom.startIndex = this.config.chart.zoom.startIndex : a.chart.zoom.startIndex = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.endIndex") ? a.chart.zoom.endIndex = this.config.chart.zoom.endIndex : a.chart.zoom.endIndex = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.groupColor") ? a.chart.grid.labels.yAxis.groupColor = this.config.chart.grid.labels.yAxis.groupColor : a.chart.grid.labels.yAxis.groupColor = null, a.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[a.theme] || this.config,
          defaultConfig: a
        }),
        customPalette: this.themePalettes[a.theme] || this.palette
      } : a;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((t, a) => {
        [null, void 0].includes(t.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: a
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((t) => {
        t.series.forEach((a, o) => {
          this.isSafeValue(a) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${t.name}' contains the value '${a}' at index ${o}.
'${a}' was converted to null to allow the chart to display.`);
        });
      }), this.showUserOptionsOnChartHover = this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.keepUserOptionState = this.FINAL_CONFIG.chart.userOptions.keepStateOnChartLeave, this.userOptionsVisible = !this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const a = this.$refs.chart.parentNode, { height: o, width: u } = a.getBoundingClientRect();
        let l = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (l = this.$refs.chartTitle, e = l.getBoundingClientRect().height);
        let A = null, N = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (A = this.$refs.chartSlicer.$el, N = A.getBoundingClientRect().height);
        let I = null, y = 0;
        this.FINAL_CONFIG.chart.legend.show && (I = this.$refs.chartLegend, y = I.getBoundingClientRect().height);
        let v = 0;
        this.$refs.source && (v = this.$refs.source.getBoundingClientRect().height);
        let O = 0;
        this.$refs.noTitle && (O = this.$refs.noTitle.getBoundingClientRect().height), this.height = o - e - y - N - v - O, this.width = u, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((G) => {
          for (const b of G)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (N = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (y = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (v = this.$refs.source.getBoundingClientRect().height), requestAnimationFrame(() => {
              this.height = b.contentBoxSize[0].blockSize - e - y - N - v - 24, this.width = b.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
            });
        }).observe(a);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(t) {
      this.selectedMinimapIndex = t;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(t) {
      t.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${t.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${t.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(t) {
      if (!t[0]) return [-10, -10, "", -10, -10];
      const a = { x: t[0].x, y: this.zero }, o = { x: t.at(-1).x, y: this.zero }, u = [];
      return t.forEach((l) => {
        u.push(`${l.x},${l.y} `);
      }), [a.x, a.y, ...u, o.x, o.y].toString();
    },
    createIndividualArea(t, a) {
      if (!t[0]) return [-10, -10, "", -10, -10];
      const o = { x: t[0] ? t[0].x : Math.min(...t.filter((e) => !!e).map((e) => e.x)), y: a }, u = { x: t.at(-1) ? t.at(-1).x : Math.min(...t.filter((e) => !!e).map((e) => e.x)), y: a }, l = [];
      return t.filter((e) => !!e).forEach((e) => {
        l.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...l, u.x, u.y].toString();
    },
    createStar: q,
    createPolygonPath: D,
    fillArray(t, a) {
      let o = Array(t).fill(0);
      for (let u = 0; u < a.length && u < t; u += 1)
        o[u] = a[u];
      return o;
    },
    async setupSlicer() {
      (this.FINAL_CONFIG.chart.zoom.startIndex !== null || this.FINAL_CONFIG.chart.zoom.endIndex !== null) && this.$refs.chartSlicer ? (this.FINAL_CONFIG.chart.zoom.startIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setStartValue(this.FINAL_CONFIG.chart.zoom.startIndex)), this.FINAL_CONFIG.chart.zoom.endIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setEndValue(this.validSlicerEnd(this.FINAL_CONFIG.chart.zoom.endIndex + 1)))) : (this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((t) => this.largestTriangleThreeBucketsArray({ data: t.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1);
    },
    refreshSlicer() {
      this.setupSlicer();
    },
    validSlicerEnd(t) {
      const a = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length));
      return t > a ? a : t < 0 || this.FINAL_CONFIG.chart.zoom.startIndex !== null && t < this.FINAL_CONFIG.chart.zoom.startIndex ? this.FINAL_CONFIG.chart.zoom.startIndex !== null ? this.FINAL_CONFIG.chart.zoom.startIndex + 1 : 1 : t;
    },
    calcRectHeight(t) {
      const a = ![null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) && this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin > 0 && this.min >= 0 ? this.drawingArea.bottom : this.zero;
      return t.value >= 0 ? this.checkNaN(a - t.y <= 0 ? 1e-5 : a - t.y) : this.checkNaN(t.y - this.zero <= 0 ? 1e-5 : t.y - this.zero);
    },
    calcIndividualHeight(t) {
      return t.value >= 0 ? this.checkNaN(t.zeroPosition - t.y <= 0 ? 1e-5 : t.zeroPosition - t.y) : this.checkNaN(t.y - t.zeroPosition <= 0 ? 1e-5 : t.zeroPosition - t.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(t) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? t.x + this.drawingArea.width / this.maxSeries * 0.05 : t.x + this.slot.bar / 2;
    },
    calcRectY(t) {
      return t.value >= 0 ? t.y : this.zero;
    },
    calcIndividualRectY(t) {
      return t.value >= 0 ? t.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(t.zeroPosition) ? 0 : t.zeroPosition;
    },
    canShowValue(t) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(t);
    },
    findClosestValue(t, a) {
      let o = a[0], u = Math.abs(t - a[0]);
      for (let l = 1; l < a.length; l += 1) {
        const e = Math.abs(t - a[l]);
        e < u && a[l] < t && (o = a[l], u = e);
      }
      return o;
    },
    ratioToMax(t) {
      return t / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(t) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((a) => ({
            name: a.name,
            value: [null, void 0, NaN].includes(a.absoluteValues[t]) ? null : a.absoluteValues[t],
            color: a.color,
            type: a.type
          })),
          index: t,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((t) => ({
        values: t.absoluteValues,
        color: t.color,
        name: t.name,
        type: t.type
      }));
    },
    segregate(t) {
      if (this.segregatedSeries.includes(t.id))
        this.segregatedSeries = this.segregatedSeries.filter((a) => a !== t.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(t.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((a) => ({
        name: a.name,
        values: a.absoluteValues,
        color: a.color,
        type: a.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(t, a = null) {
      this.isTooltip = t, t ? this.selectedSerieIndex = a : this.selectedSerieIndex = null;
    },
    toggleFullscreen(t) {
      this.isFullscreen = t, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: t } = await import("./pdf-DVWl3Adn.js");
          await t({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (t) {
          console.error("Error generating PDF:", t);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const t = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], a = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, u = t.concat([a]).concat(o), l = this.createCsvContent(u);
      this.downloadCsv({ csvContent: l, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: t } = await import("./img-itj0Vdmx.js");
          await t({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (t) {
          console.error("Error generating image:", t);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Ke = ["id"], Qe = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, je = ["viewBox", "aria-label"], $e = ["x", "y", "width", "height"], et = { key: 1 }, tt = { class: "vue-ui-xy-grid" }, lt = ["stroke", "x1", "x2", "y1", "y2"], rt = ["stroke", "x1", "x2", "y1", "y2"], it = { key: 1 }, at = ["x1", "x2", "y1", "y2", "stroke"], st = ["x1", "x2", "y1", "y2", "stroke"], nt = ["x1", "x2", "y1", "y2", "stroke"], ct = { key: 3 }, ot = ["x1", "x2", "y1", "y2", "stroke"], ht = ["id"], ut = ["stop-color"], dt = ["stop-color"], gt = ["stop-color"], ft = ["id"], It = ["stop-color"], mt = ["stop-color"], Nt = ["stop-color"], bt = ["id"], xt = ["stop-color"], Ft = ["stop-color"], _t = ["id"], At = ["stop-color"], yt = ["stop-color"], Lt = ["id"], Ct = ["stop-color"], St = ["stop-color"], kt = ["x", "y", "height", "width", "fill"], wt = ["x", "y", "width"], Ot = ["x", "y", "height", "width", "fill"], Gt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], vt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], pt = ["width", "x", "y"], zt = { key: 0 }, Mt = ["id"], Tt = ["fill"], Pt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Vt = ["x", "y", "font-size", "fill"], Rt = ["stroke", "x1", "x2", "y1", "y2"], Dt = { key: 2 }, Ht = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Wt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Bt = { key: 4 }, Et = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Yt = ["fill", "font-size", "transform"], qt = ["x1", "x2", "y1", "y2", "stroke"], Xt = ["x", "y", "font-size", "fill"], Ut = ["x1", "x2", "y1", "y2", "stroke"], Zt = ["x", "y", "font-size", "fill"], Jt = ["width", "x", "y"], Kt = { style: { width: "100%" } }, Qt = { key: 0 }, jt = ["id"], $t = ["fill"], el = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], tl = ["x", "y", "font-size", "fill"], ll = ["d", "stroke", "stroke-width", "stroke-dasharray"], rl = ["d", "stroke", "stroke-width", "stroke-dasharray"], il = { key: 5 }, al = { key: 0 }, sl = ["d", "fill"], nl = ["d", "fill"], cl = ["d", "fill"], ol = ["d", "fill"], hl = ["d", "stroke", "stroke-width", "stroke-dasharray"], ul = ["d", "stroke", "stroke-width", "stroke-dasharray"], dl = ["width", "x", "y"], gl = { style: { width: "100%" } }, fl = { key: 3 }, Il = ["id"], ml = ["fill"], Nl = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], bl = ["x", "y", "font-size", "fill"], xl = { key: 6 }, Fl = ["x", "y", "font-size", "fill"], _l = ["x", "y", "font-size", "fill", "font-weight"], Al = { key: 7 }, yl = ["x", "y", "font-size", "fill"], Ll = ["x", "y"], Cl = ["x", "y"], Sl = { key: 8 }, kl = ["x", "y", "font-size", "fill"], wl = ["x", "y"], Ol = ["x", "y"], Gl = ["x", "y", "font-size", "fill", "innerHTML"], vl = ["x", "y", "font-size", "fill", "innerHTML"], pl = ["x", "y", "font-size", "fill", "innerHTML"], zl = ["x", "y", "font-size", "fill", "innerHTML"], Ml = ["id"], Tl = ["stop-color"], Pl = ["stop-color"], Vl = ["x", "y", "width", "height", "fill", "onMouseenter"], Rl = ["font-size", "fill", "transform"], Dl = ["x", "y", "font-size", "fill"], Hl = { key: 10 }, Wl = ["text-anchor", "font-size", "fill", "transform", "onClick"], Bl = ["x", "y", "height", "width", "onMouseenter", "onClick"], El = {
  key: 11,
  style: { "pointer-events": "none" }
}, Yl = ["x", "y"], ql = ["cx", "cy", "r", "fill"], Xl = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ul = ["onClick"], Zl = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Jl = ["stroke", "fill"], Kl = {
  key: 1,
  viewBox: "0 0 40 40",
  height: "14",
  width: "14"
}, Ql = ["fill"], jl = ["fill"], $l = {
  key: 2,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, er = {
  key: 9,
  ref: "chartLegend"
}, tr = {
  key: 10,
  ref: "source",
  dir: "auto"
}, lr = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, rr = ["innerHTML"];
function ir(t, a, o, u, l, e) {
  const A = R("PenAndPaper"), N = R("Title"), I = R("UserOptions"), y = R("PackageVersion"), v = R("Shape"), O = R("Skeleton"), p = R("Slicer"), G = R("Tooltip"), b = R("BaseIcon"), L = R("TableSparkline"), z = R("DataTable"), V = R("Accordion");
  return i(), s("div", {
    id: `vue-ui-xy_${l.uniqueId}`,
    class: W(`vue-ui-xy ${l.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: F(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`),
    onMouseenter: a[7] || (a[7] = () => e.setUserOptionsVisibility(!0)),
    onMouseleave: a[8] || (a[8] = () => e.setUserOptionsVisibility(!1))
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (i(), H(A, {
      key: 0,
      svgRef: l.svgRef,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: l.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["svgRef", "backgroundColor", "color", "active", "onClose"])) : h("", !0),
    e.hasOptionsNoTitle ? (i(), s("div", Qe, null, 512)) : h("", !0),
    e.FINAL_CONFIG.chart.title.show ? (i(), s("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: F(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (i(), H(N, {
        key: `title_${l.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : h("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset && (l.keepUserOptionState || l.userOptionsVisible) ? (i(), H(I, {
      ref: "defails",
      key: `user_options_${l.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: l.isPrinting,
      isImaging: l.isImaging,
      uid: l.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: l.mutableConfig.isStacked,
      isFullscreen: l.isFullscreen,
      chartElement: t.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: l.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: l.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator,
      style: F({
        visibility: l.keepUserOptionState ? l.userOptionsVisible ? "visible" : "hidden" : "visible"
      })
    }, Ye({ _: 2 }, [
      t.$slots.menuIcon ? {
        name: "menuIcon",
        fn: P(({ isOpen: r, color: c }) => [
          S(t.$slots, "menuIcon", B(E({ isOpen: r, color: c })), void 0, !0)
        ]),
        key: "0"
      } : void 0,
      t.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: P(() => [
          S(t.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      t.$slots.optionPdf ? {
        name: "optionPdf",
        fn: P(() => [
          S(t.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      t.$slots.optionCsv ? {
        name: "optionCsv",
        fn: P(() => [
          S(t.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      t.$slots.optionImg ? {
        name: "optionImg",
        fn: P(() => [
          S(t.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      t.$slots.optionTable ? {
        name: "optionTable",
        fn: P(() => [
          S(t.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      t.$slots.optionLabels ? {
        name: "optionLabels",
        fn: P(() => [
          S(t.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      t.$slots.optionStack ? {
        name: "optionStack",
        fn: P(() => [
          S(t.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "7"
      } : void 0,
      t.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: P(({ toggleFullscreen: r, isFullscreen: c }) => [
          S(t.$slots, "optionFullscreen", B(E({ toggleFullscreen: r, isFullscreen: c })), void 0, !0)
        ]),
        key: "8"
      } : void 0,
      t.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: P(({ toggleAnnotator: r, isAnnotator: c }) => [
          S(t.$slots, "optionAnnotator", B(E({ toggleAnnotator: r, isAnnotator: c })), void 0, !0)
        ]),
        key: "9"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator", "style"])) : h("", !0),
    e.isDataset ? (i(), s("svg", {
      key: 4,
      ref: "svgRef",
      xmlns: "http://www.w3.org/2000/svg",
      class: W([{ "vue-data-ui-fullscreen--on": l.isFullscreen, "vue-data-ui-fulscreen--off": !l.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: l.viewBox,
      style: F(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`),
      "aria-label": e.chartAriaLabel,
      role: "img",
      "aria-live": "polite"
    }, [
      Y(y),
      t.$slots["chart-background"] ? (i(), s("foreignObject", {
        key: 0,
        x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
        y: e.drawingArea.top,
        width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
        height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
        style: {
          pointerEvents: "none"
        }
      }, [
        S(t.$slots, "chart-background", {}, void 0, !0)
      ], 8, $e)) : h("", !0),
      e.maxSeries > 0 ? (i(), s("g", et, [
        d("g", tt, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (i(), s("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.forceValidValue(e.drawingArea.bottom),
            y2: e.forceValidValue(e.drawingArea.bottom),
            "stroke-linecap": "round"
          }, null, 8, lt)) : h("", !0),
          l.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (i(!0), s(g, { key: 2 }, m(e.allScales, (r) => (i(), s("g", null, [
            r.id === l.selectedScale && r.yLabels.length ? (i(!0), s(g, { key: 0 }, m(r.yLabels, (c) => (i(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(c.y),
              y2: e.forceValidValue(c.y),
              stroke: r.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, st))), 256)) : r.yLabels.length ? (i(!0), s(g, { key: 1 }, m(r.yLabels, (c) => (i(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(c.y),
              y2: e.forceValidValue(c.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, nt))), 256)) : h("", !0)
          ]))), 256)) : h("", !0) : (i(), s(g, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (i(), s("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-linecap": "round"
            }, null, 8, rt)) : h("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (i(), s("g", it, [
              (i(!0), s(g, null, m(e.yLabels, (r) => (i(), s("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.forceValidValue(r.y),
                y2: e.forceValidValue(r.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, at))), 256))
            ])) : h("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (i(), s("g", ct, [
            (i(!0), s(g, null, m(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (r, c) => (i(), s("line", {
              key: `grid_vertical_line_${c}`,
              x1: e.drawingArea.width / e.maxSeries * c + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * c + e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, ot))), 128))
          ])) : h("", !0)
        ]),
        (i(!0), s(g, null, m(e.barSet, (r, c) => (i(), s("defs", {
          key: `def_rect_${c}`
        }, [
          d("linearGradient", {
            id: `rectGradient_pos_${c}_${l.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": r.color
            }, null, 8, ut),
            d("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, dt),
            d("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, gt)
          ], 8, ht),
          d("linearGradient", {
            id: `rectGradient_neg_${c}_${l.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, It),
            d("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, mt),
            d("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, Nt)
          ], 8, ft)
        ]))), 128)),
        (i(!0), s(g, null, m(e.plotSet, (r, c) => (i(), s("defs", {
          key: `def_plot_${c}`
        }, [
          d("radialGradient", {
            id: `plotGradient_${c}_${l.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, xt),
            d("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, Ft)
          ], 8, bt)
        ]))), 128)),
        (i(!0), s(g, null, m(e.lineSet, (r, c) => (i(), s("defs", {
          key: `def_line_${c}`
        }, [
          d("radialGradient", {
            id: `lineGradient_${c}_${l.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, At),
            d("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, yt)
          ], 8, _t),
          d("linearGradient", {
            id: `areaGradient_${c}_${l.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(r.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, Ct),
            d("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, St)
          ], 8, Lt)
        ]))), 128)),
        (i(!0), s(g, null, m(e.highlightAreas, (r) => (i(), s("g", null, [
          r.show ? (i(!0), s(g, { key: 0 }, m(r.span, (c, n) => (i(), s("g", null, [
            d("rect", {
              style: F({
                transition: "none",
                opacity: r.from + n >= l.slicer.start && r.from + n <= l.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - l.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(r.color, r.opacity)
            }, null, 12, kt),
            r.caption.text && n === 0 ? (i(), s("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - l.slicer.start) - (r.caption.width === "auto" ? 0 : r.caption.width / 2 - e.drawingArea.width / e.maxSeries * r.span / 2),
              y: e.drawingArea.top + r.caption.offsetY,
              style: F({
                overflow: "visible",
                opacity: r.to >= l.slicer.start && r.from < l.slicer.end ? 1 : 0
              }),
              height: "1",
              width: r.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * r.span : r.caption.width
            }, [
              d("div", {
                style: F(`padding:${r.caption.padding}px;text-align:${r.caption.textAlign};font-size:${r.caption.fontSize}px;color:${r.caption.color};font-weight:${r.caption.bold ? "bold" : "normal"}`)
              }, w(r.caption.text), 5)
            ], 12, wt)) : h("", !0)
          ]))), 256)) : h("", !0)
        ]))), 256)),
        d("g", null, [
          (i(!0), s(g, null, m(e.maxSeries, (r, c) => (i(), s("g", {
            key: `tooltip_trap_highlighter_${c}`
          }, [
            d("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * c,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [l.selectedMinimapIndex, l.selectedSerieIndex, l.selectedRowIndex].includes(c) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, Ot)
          ]))), 128))
        ]),
        e.barSet.length ? (i(!0), s(g, { key: 0 }, m(e.barSet, (r, c) => (i(), s("g", {
          key: `serie_bar_${c}`,
          class: W(`serie_bar_${c}`),
          style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s("g", {
            key: `bar_plot_${c}_${f}`
          }, [
            e.canShowValue(n.value) ? (i(), s("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: l.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: l.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${c}_${l.uniqueId})` : `url(#rectGradient_neg_${c}_${l.uniqueId})` : r.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, Gt)) : h("", !0),
            e.canShowValue(n.value) && t.$slots.pattern ? (i(), s("rect", {
              key: 1,
              x: e.calcRectX(n),
              y: l.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: l.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: `url(#pattern_${l.uniqueId}_${r.slotAbsoluteIndex})`,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, vt)) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (i(), s("foreignObject", {
              key: 2,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              S(t.$slots, "plot-comment", {
                plot: { ...n, color: r.color, seriesIndex: c, datapointIndex: f }
              }, void 0, !0)
            ], 8, pt)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (i(), s("g", zt, [
            d("defs", null, [
              d("marker", {
                id: `bar_arrow_${c}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                d("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, Tt)
              ], 8, Mt)
            ]),
            r.plots.length > 1 ? (i(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${c})`
            }, null, 8, Pt)) : h("", !0),
            r.plots.length > 1 ? (i(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": l.fontSizes.plotLabels,
              fill: r.color
            }, w(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Vt)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)) : h("", !0),
        !l.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (i(), s("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.forceValidValue(e.zero),
          y2: e.forceValidValue(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Rt)) : h("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(l.selectedSerieIndex) || ![null, void 0].includes(l.selectedMinimapIndex)) ? (i(), s("g", Dt, [
          d("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((l.selectedSerieIndex !== null ? l.selectedSerieIndex : 0) || (l.selectedMinimapIndex !== null ? l.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((l.selectedSerieIndex !== null ? l.selectedSerieIndex : 0) || (l.selectedMinimapIndex !== null ? l.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.forceValidValue(e.drawingArea.top),
            y2: e.forceValidValue(e.drawingArea.bottom),
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Ht)
        ])) : h("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (i(), s("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Wt)) : h("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (i(), s("g", Bt, [
          l.mutableConfig.useIndividualScale ? (i(), s(g, { key: 0 }, [
            (i(!0), s(g, null, m(e.allScales, (r) => (i(), s("g", null, [
              d("line", {
                x1: r.x + e.xPadding,
                x2: r.x + e.xPadding,
                y1: l.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - r.yOffset - r.individualHeight) : e.forceValidValue(e.drawingArea.top),
                y2: l.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - r.yOffset) : e.forceValidValue(e.drawingArea.bottom),
                stroke: r.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: F(`opacity:${l.selectedScale ? l.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Et)
            ]))), 256)),
            (i(!0), s(g, null, m(e.allScales, (r) => (i(), s("g", {
              style: F(`opacity:${l.selectedScale ? l.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              d("text", {
                fill: r.color,
                "font-size": l.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5 + e.xPadding}, ${l.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset - r.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, w(r.name) + " " + w(r.scaleLabel && r.unique ? `- ${r.scaleLabel}` : ""), 9, Yt),
              (i(!0), s(g, null, m(r.yLabels, (c, n) => (i(), s("line", {
                x1: r.x - 3 + e.xPadding,
                x2: r.x + e.xPadding,
                y1: e.forceValidValue(c.y),
                y2: e.forceValidValue(c.y),
                stroke: r.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, qt))), 256)),
              (i(!0), s(g, null, m(r.yLabels, (c, n) => (i(), s("text", {
                x: r.x - 5 + e.xPadding,
                y: e.forceValidValue(c.y) + l.fontSizes.dataLabels / 3,
                "font-size": l.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: r.color
              }, w(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                c.value,
                e.dataLabel({
                  p: c.prefix,
                  v: c.value,
                  s: c.suffix,
                  r: 1
                }),
                { datapoint: c.datapoint, seriesIndex: n }
              )), 9, Xt))), 256))
            ], 4))), 256))
          ], 64)) : (i(!0), s(g, { key: 1 }, m(e.yLabels, (r, c) => (i(), s("g", {
            key: `yLabel_${c}`
          }, [
            e.canShowValue(r) && r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (i(), s("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.forceValidValue(r.y),
              y2: e.forceValidValue(r.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Ut)) : h("", !0),
            r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (i(), s("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(r.y + l.fontSizes.dataLabels / 3),
              "font-size": l.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, w(e.canShowValue(r.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              r.value,
              e.dataLabel({
                p: r.prefix,
                v: r.value,
                s: r.suffix,
                r: 1
              })
            ) : ""), 9, Zt)) : h("", !0)
          ]))), 128))
        ])) : h("", !0),
        (i(!0), s(g, null, m(e.plotSet, (r, c) => (i(), s("g", {
          key: `serie_plot_${c}`,
          class: W(`serie_plot_${c}`),
          style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s("g", {
            key: `circle_plot_${c}_${f}`
          }, [
            n && e.canShowValue(n.value) ? (i(), H(v, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${c}_${l.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? r.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: l.selectedSerieIndex !== null && l.selectedSerieIndex === f || l.selectedMinimapIndex !== null && l.selectedMinimapIndex === f ? (l.plotRadii.plot || 6) * 1.5 : l.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (i(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              d("div", Kt, [
                S(t.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: c, datapointIndex: f }
                }, void 0, !0)
              ])
            ], 8, Jt)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (i(), s("g", Qt, [
            d("defs", null, [
              d("marker", {
                id: `plot_arrow_${c}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                d("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, $t)
              ], 8, jt)
            ]),
            r.plots.length > 1 ? (i(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${c})`
            }, null, 8, el)) : h("", !0),
            r.plots.length > 1 ? (i(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": l.fontSizes.plotLabels,
              fill: r.color
            }, w(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, tl)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)),
        (i(!0), s(g, null, m(e.lineSet, (r, c) => (i(), s("g", {
          key: `serie_line_${c}`,
          class: W(`serie_line_${c}`),
          style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.smooth && r.plots.length > 1 ? (i(), s("path", {
            key: 0,
            d: `M${r.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ll)) : r.plots.length > 1 ? (i(), s("path", {
            key: 1,
            d: `M${r.straight}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 8, rl)) : h("", !0)
        ], 6))), 128)),
        t.$slots.pattern ? (i(), s("defs", il, [
          (i(!0), s(g, null, m(e.safeDataset, (r, c) => S(t.$slots, "pattern", K({
            key: `serie_pattern_slot_${c}`,
            ref_for: !0
          }, { ...r, seriesIndex: r.slotAbsoluteIndex, patternId: `pattern_${l.uniqueId}_${c}` }), void 0, !0)), 128))
        ])) : h("", !0),
        (i(!0), s(g, null, m(e.lineSet, (r, c) => (i(), s("g", {
          key: `serie_line_${c}`,
          class: W(`serie_line_${c}`),
          style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.useArea && r.plots.length > 1 ? (i(), s("g", al, [
            r.smooth ? (i(), s(g, { key: 0 }, [
              d("path", {
                d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${l.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * c + e.slot.line / 2},${l.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${c}_${l.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, sl),
              t.$slots.pattern ? (i(), s("path", {
                key: 0,
                d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${l.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * c + e.slot.line / 2},${l.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
                fill: `url(#pattern_${l.uniqueId}_${r.slotAbsoluteIndex})`
              }, null, 8, nl)) : h("", !0)
            ], 64)) : (i(), s(g, { key: 1 }, [
              d("path", {
                d: `M${r.area}Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${c}_${l.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, cl),
              t.$slots.pattern ? (i(), s("path", {
                key: 0,
                d: `M${r.area}Z`,
                fill: `url(#pattern_${l.uniqueId}_${r.slotAbsoluteIndex})`
              }, null, 8, ol)) : h("", !0)
            ], 64))
          ])) : h("", !0),
          r.smooth && r.plots.length > 1 ? (i(), s("path", {
            key: 1,
            d: `M${r.curve}`,
            stroke: r.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round"
          }, null, 8, hl)) : r.plots.length > 1 ? (i(), s("path", {
            key: 2,
            d: `M${r.straight}`,
            stroke: r.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 8, ul)) : h("", !0),
          (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s(g, {
            key: `circle_line_${c}_${f}`
          }, [
            !e.optimize.linePlot && n && e.canShowValue(n.value) || e.optimize.linePlot && n && e.canShowValue(n.value) && (l.selectedSerieIndex !== null && l.selectedSerieIndex === f || l.selectedMinimapIndex !== null && l.selectedMinimapIndex === f) ? (i(), H(v, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${c}_${l.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? r.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: l.selectedSerieIndex !== null && l.selectedSerieIndex === f || l.selectedMinimapIndex !== null && l.selectedMinimapIndex === f ? (l.plotRadii.line || 6) * 1.5 : l.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (i(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              d("div", gl, [
                S(t.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: c, datapointIndex: f }
                }, void 0, !0)
              ])
            ], 8, dl)) : h("", !0)
          ], 64))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (i(), s("g", fl, [
            d("defs", null, [
              d("marker", {
                id: `line_arrow_${c}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                d("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, ml)
              ], 8, Il)
            ]),
            r.plots.length > 1 ? (i(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${c})`
            }, null, 8, Nl)) : h("", !0),
            r.plots.length > 1 ? (i(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": l.fontSizes.plotLabels,
              fill: r.color
            }, w(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, bl)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && l.mutableConfig.dataLabels.show ? (i(), s("g", xl, [
          (i(!0), s(g, null, m(e.barSet, (r, c) => (i(), s(g, {
            key: `xLabel_bar_${c}`
          }, [
            (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s(g, {
              key: `xLabel_bar_${c}_${f}`
            }, [
              n && (!Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || l.selectedSerieIndex !== null && l.selectedSerieIndex === f || l.selectedMinimapIndex !== null && l.selectedMinimapIndex === f) && e.FINAL_CONFIG.bar.labels.show ? (i(), s("text", {
                key: 0,
                x: l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": l.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color,
                style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, w(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 13, Fl)) : h("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (i(), s("text", {
                key: 1,
                x: l.mutableConfig.useIndividualScale && l.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": l.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? r.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal",
                style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, w(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: r.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : r.name), 13, _l)) : h("", !0)
            ], 64))), 128))
          ], 64))), 128))
        ])) : h("", !0),
        e.FINAL_CONFIG.plot.labels.show && l.mutableConfig.dataLabels.show ? (i(), s("g", Al, [
          (i(!0), s(g, null, m(e.plotSet, (r, c) => (i(), s(g, {
            key: `xLabel_plot_${c}`
          }, [
            (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s(g, {
              key: `xLabel_plot_${c}_${f}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || l.selectedSerieIndex !== null && l.selectedSerieIndex === f || l.selectedMinimapIndex !== null && l.selectedMinimapIndex === f ? (i(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": l.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color,
                style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, w(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 13, yl)) : h("", !0),
              n && f === 0 && r.useTag && r.useTag === "start" ? (i(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: F(`overflow: visible; opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, [
                d("div", {
                  style: F(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${l.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 12, Ll)) : h("", !0),
              n && f === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (i(), s("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (l.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: F(`overflow: visible; opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, [
                d("div", {
                  style: F(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${l.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 12, Cl)) : h("", !0)
            ], 64))), 128))
          ], 64))), 128))
        ])) : h("", !0),
        e.FINAL_CONFIG.line.labels.show && l.mutableConfig.dataLabels.show ? (i(), s("g", Sl, [
          (i(!0), s(g, null, m(e.lineSet, (r, c) => (i(), s(g, {
            key: `xLabel_line_${c}`
          }, [
            (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s(g, {
              key: `xLabel_line_${c}_${f}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || l.selectedSerieIndex !== null && l.selectedSerieIndex === f || l.selectedMinimapIndex !== null && l.selectedMinimapIndex === f ? (i(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": l.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color,
                style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, w(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 13, kl)) : h("", !0),
              n && f === 0 && r.useTag && r.useTag === "start" ? (i(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: F(`overflow: visible; opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, [
                d("div", {
                  style: F(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${l.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 12, wl)) : h("", !0),
              n && f === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (i(), s("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (l.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: F(`overflow: visible; opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
              }, [
                d("div", {
                  style: F(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${l.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 12, Ol)) : h("", !0)
            ], 64))), 128))
          ], 64))), 128))
        ])) : h("", !0),
        (i(!0), s(g, null, m(e.lineSet, (r, c) => (i(), s(g, {
          key: `xLabel_line_${c}`
        }, [
          (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s(g, {
            key: `xLabel_line_${c}_${f}`
          }, [
            n && f === 0 && r.showSerieName && r.showSerieName === "start" ? (i(), s("text", {
              key: 0,
              x: n.x - l.fontSizes.plotLabels,
              y: n.y,
              "font-size": l.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: l.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - l.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              }),
              style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
            }, null, 12, Gl)) : h("", !0),
            n && f === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (i(), s("text", {
              key: 1,
              x: n.x + l.fontSizes.plotLabels,
              y: n.y,
              "font-size": l.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: l.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + l.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              }),
              style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
            }, null, 12, vl)) : h("", !0)
          ], 64))), 128))
        ], 64))), 128)),
        (i(!0), s(g, null, m(e.plotSet, (r, c) => (i(), s(g, {
          key: `xLabel_plot_${c}`
        }, [
          (i(!0), s(g, null, m(r.plots, (n, f) => (i(), s(g, {
            key: `xLabel_plot_${c}_${f}`
          }, [
            n && f === 0 && r.showSerieName && r.showSerieName === "start" ? (i(), s("text", {
              key: 0,
              x: n.x - l.fontSizes.plotLabels,
              y: n.y,
              "font-size": l.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: l.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - l.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              }),
              style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
            }, null, 12, pl)) : h("", !0),
            n && f === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (i(), s("text", {
              key: 1,
              x: n.x + l.fontSizes.plotLabels,
              y: n.y,
              "font-size": l.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: l.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + l.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              }),
              style: F(`opacity:${l.selectedScale ? l.selectedScale === r.groupId ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
            }, null, 12, zl)) : h("", !0)
          ], 64))), 128))
        ], 64))), 128)),
        l.mutableConfig.useIndividualScale && !l.mutableConfig.isStacked ? (i(), s(g, { key: 9 }, [
          d("defs", null, [
            (i(!0), s(g, null, m(e.allScales, (r, c) => (i(), s("linearGradient", {
              id: `individual_scale_gradient_${l.uniqueId}_${c}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              d("stop", {
                offset: "0%",
                "stop-color": e.FINAL_CONFIG.chart.backgroundColor,
                "stop-opacity": "0"
              }, null, 8, Tl),
              d("stop", {
                offset: "100%",
                "stop-color": r.color,
                "stop-opacity": "0.2"
              }, null, 8, Pl)
            ], 8, Ml))), 256))
          ]),
          (i(!0), s(g, null, m(e.allScales, (r, c) => (i(), s("rect", {
            x: r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + e.xPadding,
            y: e.drawingArea.top,
            width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            fill: l.selectedScale === r.groupId ? `url(#individual_scale_gradient_${l.uniqueId}_${c})` : "transparent",
            onMouseenter: (n) => l.selectedScale = r.groupId,
            onMouseleave: a[0] || (a[0] = (n) => l.selectedScale = null)
          }, null, 40, Vl))), 256))
        ], 64)) : h("", !0),
        d("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !l.mutableConfig.useIndividualScale ? (i(), s("text", {
            key: 0,
            "font-size": l.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${l.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, w(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Rl)) : h("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (i(), s("text", {
            key: 1,
            "text-anchor": "middle",
            x: l.width / 2,
            y: e.drawingArea.bottom + l.fontSizes.yAxis + l.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": l.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, w(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Dl)) : h("", !0)
        ]),
        a[9] || (a[9] = J('v-for="(label, i) in timeLabels" :key="`time_label_${i}`" ')),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (i(), s("g", Hl, [
          t.$slots["time-label"] ? (i(!0), s(g, { key: 0 }, m(e.timeLabels, (r, c) => S(t.$slots, "time-label", K({
            key: `time_label_${c}`,
            ref_for: !0
          }, {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * c + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom + l.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset,
            fontSize: l.fontSizes.xAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
            transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * c + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + l.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
            absoluteIndex: r.absoluteIndex,
            content: r.text,
            textAnchor: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
            show: r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (c === 0 || c === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && l.selectedSerieIndex === c && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && c % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0
          }), void 0, !0)), 128)) : (i(!0), s(g, { key: 1 }, m(e.timeLabels, (r, c) => (i(), s("g", {
            key: `time_label_${c}`
          }, [
            r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (c === 0 || c === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && l.selectedSerieIndex === c && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && c % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (i(), s("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": l.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * c + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + l.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              style: {
                cursor: "pointer"
              },
              onClick: () => e.selectTimeLabel(r, c)
            }, w(r.text || ""), 9, Wl)) : h("", !0)
          ]))), 128))
        ])) : h("", !0),
        d("g", null, [
          (i(!0), s(g, null, m(e.maxSeries, (r, c) => (i(), s("rect", {
            key: `tooltip_trap_${c}`,
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * c,
            y: e.drawingArea.top,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
            fill: "transparent",
            onMouseenter: (n) => e.toggleTooltipVisibility(!0, c),
            onMouseleave: a[1] || (a[1] = (n) => e.toggleTooltipVisibility(!1)),
            onClick: (n) => e.selectX(c)
          }, null, 40, Bl))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(l.selectedSerieIndex) || ![null, void 0].includes(l.selectedMinimapIndex)) ? (i(), s("g", El, [
          (i(), s("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((l.selectedSerieIndex !== null ? l.selectedSerieIndex : 0) || (l.selectedMinimapIndex !== null ? l.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            d("div", {
              class: "vue-ui-xy-time-tag",
              style: F(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, w(e.timeLabels[(l.selectedSerieIndex !== null ? l.selectedSerieIndex : 0) || (l.selectedMinimapIndex !== null ? l.selectedMinimapIndex : 0)].text || (l.selectedSerieIndex !== null ? l.selectedSerieIndex : 0) || (l.selectedMinimapIndex !== null ? l.selectedMinimapIndex : 0)), 5)
          ], 8, Yl)),
          d("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((l.selectedSerieIndex !== null ? l.selectedSerieIndex : 0) || (l.selectedMinimapIndex !== null ? l.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, ql)
        ])) : h("", !0)
      ])) : h("", !0),
      S(t.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, je)) : h("", !0),
    t.$slots.watermark ? (i(), s("div", Xl, [
      S(t.$slots, "watermark", B(E({ isPrinting: l.isPrinting || l.isImaging })), void 0, !0)
    ])) : h("", !0),
    e.isDataset ? h("", !0) : (i(), H(O, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && l.maxX > 6 && e.isDataset ? (i(), H(p, {
      ref: "chartSlicer",
      key: `slicer_${l.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[l.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[l.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: l.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      verticalHandles: e.FINAL_CONFIG.chart.zoom.minimap.verticalHandles,
      max: l.maxX,
      min: 0,
      valueStart: l.slicer.start,
      valueEnd: l.slicer.end,
      start: l.slicer.start,
      "onUpdate:start": a[2] || (a[2] = (r) => l.slicer.start = r),
      end: l.slicer.end,
      "onUpdate:end": a[3] || (a[3] = (r) => l.slicer.end = r),
      refreshStartPoint: e.FINAL_CONFIG.chart.zoom.startIndex !== null ? e.FINAL_CONFIG.chart.zoom.startIndex : 0,
      refreshEndPoint: e.FINAL_CONFIG.chart.zoom.endIndex !== null ? e.FINAL_CONFIG.chart.zoom.endIndex + 1 : Math.max(...o.dataset.map((r) => e.largestTriangleThreeBucketsArray({ data: r.series, threshold: e.FINAL_CONFIG.downsample.threshold }).length)),
      enableRangeHandles: e.FINAL_CONFIG.chart.zoom.enableRangeHandles,
      enableSelectionDrag: e.FINAL_CONFIG.chart.zoom.enableSelectionDrag,
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": P(({ reset: r }) => [
        S(t.$slots, "reset-action", B(E({ reset: r })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "verticalHandles", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag", "onReset", "onTrapMouse"])) : h("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (i(), s("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: F(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (i(!0), s(g, null, m(e.absoluteDataset, (r, c) => (i(), s("div", {
        key: `div_legend_item_${c}`,
        onClick: (n) => e.segregate(r),
        class: W({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": l.segregatedSeries.includes(r.id) })
      }, [
        l.icons[r.type] === "line" ? (i(), s("svg", Zl, [
          d("rect", {
            x: "0",
            y: "7.5",
            rx: "1.5",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": 0.5,
            height: "3",
            width: "20",
            fill: r.color
          }, null, 8, Jl),
          Y(v, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 0.5
          }, null, 8, ["color", "shape", "stroke"])
        ])) : l.icons[r.type] === "bar" ? (i(), s("svg", Kl, [
          l.icons[r.type] === "bar" && t.$slots.pattern ? (i(), s("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: r.color
          }, null, 8, Ql)) : h("", !0),
          l.icons[r.type] === "bar" ? (i(), s("rect", {
            key: 1,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: t.$slots.pattern ? `url(#pattern_${l.uniqueId}_${r.slotAbsoluteIndex})` : r.color
          }, null, 8, jl)) : h("", !0)
        ])) : (i(), s("svg", $l, [
          Y(v, {
            plot: { x: 6, y: 6 },
            radius: 5,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle"
          }, null, 8, ["color", "shape"])
        ])),
        d("span", {
          style: F(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, w(r.name), 5)
      ], 10, Ul))), 128))
    ], 4)) : (i(), s("div", er, [
      S(t.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    t.$slots.source ? (i(), s("div", tr, [
      S(t.$slots, "source", {}, void 0, !0)
    ], 512)) : h("", !0),
    Y(G, {
      show: l.mutableConfig.showTooltip && l.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: t.$refs.chart,
      content: e.tooltipContent,
      isFullscreen: l.isFullscreen,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": P(() => [
        S(t.$slots, "tooltip-before", B(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": P(() => [
        S(t.$slots, "tooltip-after", B(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
    e.isDataset ? (i(), H(V, {
      key: 11,
      hideDetails: "",
      config: {
        open: l.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: P(() => [
        d("div", {
          style: F(`${l.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          d("div", lr, [
            qe(d("input", {
              type: "checkbox",
              "onUpdate:modelValue": a[4] || (a[4] = (r) => l.showSparklineTable = r)
            }, null, 512), [
              [Xe, l.showSparklineTable]
            ]),
            d("div", {
              onClick: a[5] || (a[5] = (r) => l.showSparklineTable = !l.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              Y(b, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          l.showSparklineTable ? (i(), H(L, {
            key: `sparkline_${l.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (i(), H(z, {
            key: `table_${l.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: a[6] || (a[6] = (r) => l.mutableConfig.showTable = !1)
          }, {
            th: P(({ th: r }) => [
              d("div", { innerHTML: r }, null, 8, rr)
            ]),
            td: P(({ td: r }) => [
              J(w(isNaN(Number(r)) ? r : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: r,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : h("", !0)
  ], 46, Ke);
}
const _r = /* @__PURE__ */ Ue(Je, [["render", ir], ["__scopeId", "data-v-3f5f4244"]]);
export {
  _r as default
};
